//+------------------------------------------------------------------+
//|                                       IchimokuK2sssp[cw].mq4  ik  |
//| kijun, kijunA        Copyright  2004, MetaQuotes Software Corp.  |
//|separate SenkouAB & Chinkou SpanShift. http://www.metaquotes.net   |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 FireBrick
#property indicator_color2  DarkSlateBlue
#property indicator_color3  Blue
#property indicator_color4 Indigo
#property indicator_color5 Purple 
#property indicator_color6  DarkSlateGray
#property indicator_color7 DarkSlateGray
#property indicator_color8 Red
//---- input parameters
extern int Tenkan=9;
extern int Kijun=26;
extern int KijunA=38;     //if=senkou - leading kumo
extern int Senkou=52;
extern int SenkouSpanShift=0;
extern int ChinkouSpanShift=0;

//---- buffers
double Tenkan_Buffer[];
double KijunA_Buffer[];
double Kijun_Buffer[];

double Senkou_Buffer[];
double SpanA_Buffer[];
double SpanB_Buffer[];
//double ChinkouZen_Buffer[];
double Chinkou_Buffer[];
double SpanA2_Buffer[];
double SpanB2_Buffer[];
//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexStyle(0,DRAW_LINE );
   SetIndexBuffer(0,Tenkan_Buffer);
   SetIndexDrawBegin(0,Tenkan-1);
   SetIndexLabel(0,"TenkanSen "+Tenkan+"");
//----
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Kijun_Buffer);
   SetIndexDrawBegin(2,Kijun-1);
   SetIndexLabel(2,"KijunSen"+Kijun+"");
//----

//----
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,KijunA_Buffer);
   SetIndexDrawBegin(1,KijunA-1);
     SetIndexShift(1,0 );
   SetIndexLabel(1,"KijunA"+KijunA+""); 

   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,Senkou_Buffer);
   SetIndexDrawBegin(5,Senkou-1);
     SetIndexShift(5,1 );
   SetIndexLabel(5,"Senkou"+Senkou+""); 

//----
   a_begin=Kijun; if(a_begin<Tenkan) a_begin=Tenkan;

   SetIndexStyle(3,DRAW_LINE,0,2);
   SetIndexBuffer(3,SpanA2_Buffer);
   SetIndexDrawBegin(3,Kijun+a_begin-1);
   SetIndexShift(3,Kijun -SenkouSpanShift);
   SetIndexLabel(3,"SenkouSpanA,Shift"+SenkouSpanShift+"");
//----

   SetIndexStyle(4,DRAW_LINE,0,2);
   SetIndexBuffer(4,SpanB2_Buffer);
   SetIndexDrawBegin(4,Kijun+Senkou-1);
   SetIndexShift(4,Kijun -SenkouSpanShift);
   SetIndexLabel(4,"SenkouSpanB,Shift"+SenkouSpanShift+"");

//----
//   SetIndexStyle(5,DRAW_LINE);
//   SetIndexBuffer(5,ChinkouZen_Buffer);
//   SetIndexShift(5,0);
//   SetIndexLabel(5,"ChinkouSpanZen"); 
//----
   SetIndexStyle(6,DRAW_LINE,0,2);
   SetIndexBuffer(6,Chinkou_Buffer);
   SetIndexShift(6,-Kijun +ChinkouSpanShift);
 //     SetIndexShift(3,-Kijun +SpanShift);
   SetIndexLabel(6,"ChinkouSpan, Shift"+ChinkouSpanShift+"");
//----


   return(0);
  }
//+------------------------------------------------------------------+
//| Ichimoku Kinko Hyo                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k;
   int    counted_bars=IndicatorCounted();
   double high,low,price;
//----
   if(Bars<=Tenkan || Bars<=Kijun || Bars<=KijunA || Bars<=Senkou) return(0);
//---- initial zero
   if(counted_bars<1)
     {
      for(i=1;i<=Tenkan;i++)    Tenkan_Buffer[Bars-i]=0;
      for(i=1;i<=Kijun;i++)     Kijun_Buffer[Bars-i]=0;
      for(i=1;i<=KijunA;i++)    KijunA_Buffer[Bars-i]=0;
      for(i=1;i<=Senkou;i++)    Senkou_Buffer[Bars-i]=0;


      for(i=1;i<=a_begin;i++) { SpanA_Buffer[Bars-i]=0; SpanA2_Buffer[Bars-i]=0; }
      for(i=1;i<=Senkou;i++)  { SpanB_Buffer[Bars-i]=0; SpanB2_Buffer[Bars-i]=0; }
     }
//---- Tenkan Sen
   i=Bars-Tenkan;
   if(counted_bars>Tenkan) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Tenkan;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Tenkan_Buffer[i]=(high+low)/2;
      i--;
     }
//---- Kijun Sen
   i=Bars-Kijun;
   if(counted_bars>Kijun) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Kijun;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Kijun_Buffer[i]=(high+low)/2;
      i--;
     }
     
     //---- Kijun2
   i=Bars-KijunA;
   if(counted_bars>KijunA) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+KijunA;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      KijunA_Buffer[i]=(high+low)/2;
      i--;
     }
//----

    //---- Senkou
   i=Bars-Senkou;
   if(counted_bars>KijunA) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Senkou;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      Senkou_Buffer[i]=(high+low)/2;
      i--;
     }
     
//---- Senkou Span A
   i=Bars-a_begin+1;
   if(counted_bars>a_begin-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      price=(Kijun_Buffer[i]+Tenkan_Buffer[i])/2;
      SpanA_Buffer[i]=price;
      SpanA2_Buffer[i]=price;
      i--;
     }
//---- Senkou Span B
   i=Bars-Senkou;
   if(counted_bars>Senkou) i=Bars-counted_bars-1;
   while(i>=0)
     {
      high=High[i]; low=Low[i]; k=i-1+Senkou;
      while(k>=i)
        {
         price=High[k];
         if(high<price) high=price;
         price=Low[k];
         if(low>price)  low=price;
         k--;
        }
      price=(high+low)/2;
      SpanB_Buffer[i]=price;
      SpanB2_Buffer[i]=price;
      i--;
     }
//---- ChinkouZenSpan
 //  i=Bars-1;
//   if(counted_bars>1) i=Bars-counted_bars-1;
 //  while(i>=0) { ChinkouZen_Buffer[i]=Close[i]; i--; }

//---- Chinkou Span
   i=Bars-1;
   if(counted_bars>1) i=Bars-counted_bars-1;
   while(i>=0) { Chinkou_Buffer[i]=Close[i]; i--; }
//----
   return(0);
  }
//+------------------------------------------------------------------+